coreEngine.Helper.ASCIIAdapter

## Class ASCIISeedFileAdapter_GPMLFormat

- java.lang.Object
- - coreEngine.Helper.ASCIIAdapter.ASCIISeedFileAdapter_GPMLFormat

-     public class ASCIISeedFileAdapter_GPMLFormat
      extends java.lang.Object

  This class import/export a Seed instance from/to an ASCII file using better format. The ASCII(text) input file contains seed input data for GP and ML segments, but RL and ATDM are not included.
  Author:
    Shu Liu

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `private class` | `ASCIISeedFileAdapter_GPMLFormat.Item` Privet helper class for output item parameters

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private static int` | `BOOLEAN` Data type marker
    `private static int` | `FLOAT` Data type marker
    `private static java.text.DecimalFormat` | `formatter` The output formatter
    `private static int` | `GENERAL_INFO` Data type marker
    `private static java.lang.String` | `ID_ACC_DEC_LANE_LENGTH` Item ID constant
    `private static java.lang.String` | `ID_ALPHA` Item ID constant
    `private static java.lang.String` | `ID_DEMAND_VEH` Item ID constant
    `private static java.lang.String` | `ID_END` Item ID constant
    `private static java.lang.String` | `ID_FFS_KNOWN` Item ID constant
    `private static java.lang.String` | `ID_FREE_FLOW_SPEED` Item ID constant
    `private static java.lang.String` | `ID_GP_OCCU` Item ID constant
    `private static java.lang.String` | `ID_JAM_DENSITY` Item ID constant
    `private static java.lang.String` | `ID_LATERAL_CLEARANCE` Item ID constant
    `private static java.lang.String` | `ID_LENGTH_OF_WEAVING` Item ID constant
    `private static java.lang.String` | `ID_MIN_LANE_CHANGE_FRWY_TO_OFR` Item ID constant
    `private static java.lang.String` | `ID_MIN_LANE_CHANGE_ONR_TO_FRWY` Item ID constant
    `private static java.lang.String` | `ID_MIN_LANE_CHANGE_ONR_TO_OFR` Item ID constant
    `private static java.lang.String` | `ID_ML_ACC_DEC_LANE_LENGTH` Item ID constant
    `private static java.lang.String` | `ID_ML_CROSS_WEAVE_LC_MIN` Item ID constant
    `private static java.lang.String` | `ID_ML_CROSS_WEAVE_VOLUME` Item ID constant
    `private static java.lang.String` | `ID_ML_DEMAND_VEH` Item ID constant
    `private static java.lang.String` | `ID_ML_FREE_FLOW_SPEED` Item ID constant
    `private static java.lang.String` | `ID_ML_HAS_CROSS_WEAVE` Item ID constant
    `private static java.lang.String` | `ID_ML_LC_MAX` Item ID constant
    `private static java.lang.String` | `ID_ML_LC_MIN` Item ID constant
    `private static java.lang.String` | `ID_ML_LENGTH_SHORT` Item ID constant
    `private static java.lang.String` | `ID_ML_MIN_LANE_CHANGE_FRWY_TO_OFR` Item ID constant
    `private static java.lang.String` | `ID_ML_MIN_LANE_CHANGE_ONR_TO_FRWY` Item ID constant
    `private static java.lang.String` | `ID_ML_MIN_LANE_CHANGE_ONR_TO_OFR` Item ID constant
    `private static java.lang.String` | `ID_ML_NUM_LANES` Item ID constant
    `private static java.lang.String` | `ID_ML_NUM_LANES_WEAVING` Item ID constant
    `private static java.lang.String` | `ID_ML_NUM_OFF_RAMP_LANES` Item ID constant
    `private static java.lang.String` | `ID_ML_NUM_ON_RAMP_LANES` Item ID constant
    `private static java.lang.String` | `ID_ML_OCCU` Item ID constant
    `private static java.lang.String` | `ID_ML_OFF_RAMP_DEMAND_VEH` Item ID constant
    `private static java.lang.String` | `ID_ML_OFF_RAMP_FREE_FLOW_SPEED` Item ID constant
    `private static java.lang.String` | `ID_ML_OFF_RAMP_SIDE` Item ID constant
    `private static java.lang.String` | `ID_ML_ON_RAMP_DEMAND_VEH` Item ID constant
    `private static java.lang.String` | `ID_ML_ON_RAMP_FREE_FLOW_SPEED` Item ID constant
    `private static java.lang.String` | `ID_ML_ON_RAMP_SIDE` Item ID constant
    `private static java.lang.String` | `ID_ML_RAMP_TO_RAMP_DEMAND_VEH` Item ID constant
    `private static java.lang.String` | `ID_ML_SEGMENT_TYPE` Item ID constant
    `private static java.lang.String` | `ID_ML_SEPARATION_TYPE` Item ID constant
    `private static java.lang.String` | `ID_ML_TRUCK_SINGLE_PERCENTAGE` Item ID constant
    `private static java.lang.String` | `ID_ML_TRUCK_TRAILER_PERCENTAGE` Item ID constant
    `private static java.lang.String` | `ID_ML_UCAF` Item ID constant
    `private static java.lang.String` | `ID_ML_UDAF` Item ID constant
    `private static java.lang.String` | `ID_ML_UOAF` Item ID constant
    `private static java.lang.String` | `ID_ML_USAF` Item ID constant
    `private static java.lang.String` | `ID_ML_USED` Item ID constant
    `private static java.lang.String` | `ID_NUM_LANES` Item ID constant
    `private static java.lang.String` | `ID_NUM_LANES_WEAVING` Item ID constant
    `private static java.lang.String` | `ID_NUM_OFF_RAMP_LANES` Item ID constant
    `private static java.lang.String` | `ID_NUM_ON_RAMP_LANES` Item ID constant
    `private static java.lang.String` | `ID_NUM_SEGMENTS` Item ID constant
    `private static java.lang.String` | `ID_OFF_RAMP_DEMAND_VEH` Item ID constant
    `private static java.lang.String` | `ID_OFF_RAMP_FREE_FLOW_SPEED` Item ID constant
    `private static java.lang.String` | `ID_OFF_RAMP_SIDE` Item ID constant
    `private static java.lang.String` | `ID_ON_RAMP_DEMAND_VEH` Item ID constant
    `private static java.lang.String` | `ID_ON_RAMP_FREE_FLOW_SPEED` Item ID constant
    `private static java.lang.String` | `ID_ON_RAMP_METERING_RATE` Item ID constant
    `private static java.lang.String` | `ID_ON_RAMP_SIDE` Item ID constant
    `private static java.lang.String` | `ID_PROJECT_NAME` Item ID constant
    `private static java.lang.String` | `ID_RAMP_METERING` Item ID constant
    `private static java.lang.String` | `ID_RAMP_TO_RAMP_DEMAND_VEH` Item ID constant
    `private static java.lang.String` | `ID_SEED_DEMAND_DATE` Item ID constant
    `private static java.lang.String` | `ID_SEGMENT_LENGTH` Item ID constant
    `private static java.lang.String` | `ID_SEGMENT_TYPE` Item ID constant
    `private static java.lang.String` | `ID_SEGMENT_WIDTH` Item ID constant
    `private static java.lang.String` | `ID_START` Item ID constant
    `private static java.lang.String` | `ID_TERRAIN` Item ID constant
    `private static java.lang.String` | `ID_TRUCK_CAR_EQ` Item ID constant
    `private static java.lang.String` | `ID_TRUCK_SINGLE_PERCENTAGE` Item ID constant
    `private static java.lang.String` | `ID_TRUCK_TRAILER_PERCENTAGE` Item ID constant
    `private static java.lang.String` | `ID_U_CAF` Item ID constant
    `private static java.lang.String` | `ID_U_DAF` Item ID constant
    `private static java.lang.String` | `ID_U_DPCAF` Item ID constant
    `private static java.lang.String` | `ID_U_DPSAF` Item ID constant
    `private static java.lang.String` | `ID_U_OAF` Item ID constant
    `private static java.lang.String` | `ID_U_SAF` Item ID constant
    `private static java.lang.String` | `ID_URBAN_RURAL` Item ID constant
    `private java.util.HashMap<java.lang.String,java.lang.String>` | `idToHeaderMap` Map to convert id to header
    `private static int` | `INTEGER` Data type marker
    `private static int` | `ITEM_WIDTH` Format marker
    `private java.util.ArrayList<ASCIISeedFileAdapter_GPMLFormat.Item>` | `itemListGP` Item list for general purpose segments
    `private java.util.ArrayList<ASCIISeedFileAdapter_GPMLFormat.Item>` | `itemListML` Item list for managed lanes segments
    `private static int` | `OTHER` Data type marker
    `private static java.lang.String` | `STR_ACC_DEC_LANE_LENGTH` Item header constant
    `private static java.lang.String` | `STR_ALPHA` Item header constant
    `private static java.lang.String` | `STR_DEMAND_VEH` Item header constant
    `private static java.lang.String` | `STR_END` Item header constant
    `private static java.lang.String` | `STR_FFS_KNOWN` Item header constant
    `private static java.lang.String` | `STR_FREE_FLOW_SPEED` Item header constant
    `private static java.lang.String` | `STR_GP_OCCU` Item header constant
    `private static java.lang.String` | `STR_JAM_DENSITY` Item header constant
    `private static java.lang.String` | `STR_LATERAL_CLEARANCE` Item header constant
    `private static java.lang.String` | `STR_LENGTH_OF_WEAVING` Item header constant
    `private static java.lang.String` | `STR_MIN_LANE_CHANGE_FRWY_TO_OFR` Item header constant
    `private static java.lang.String` | `STR_MIN_LANE_CHANGE_ONR_TO_FRWY` Item header constant
    `private static java.lang.String` | `STR_MIN_LANE_CHANGE_ONR_TO_OFR` Item header constant
    `private static java.lang.String` | `STR_ML_ACC_DEC_LANE_LENGTH` Item header constant
    `private static java.lang.String` | `STR_ML_CROSS_WEAVE_LC_MIN` Item header constant
    `private static java.lang.String` | `STR_ML_CROSS_WEAVE_VOLUME` Item header constant
    `private static java.lang.String` | `STR_ML_DEMAND_VEH` Item header constant
    `private static java.lang.String` | `STR_ML_FREE_FLOW_SPEED` Item header constant
    `private static java.lang.String` | `STR_ML_HAS_CROSS_WEAVE` Item header constant
    `private static java.lang.String` | `STR_ML_LC_MAX` Item header constant
    `private static java.lang.String` | `STR_ML_LC_MIN` Item header constant
    `private static java.lang.String` | `STR_ML_LENGTH_SHORT` Item header constant
    `private static java.lang.String` | `STR_ML_METHOD_TYPE` Item header constant
    `private static java.lang.String` | `STR_ML_MIN_LANE_CHANGE_FRWY_TO_OFR` Item header constant
    `private static java.lang.String` | `STR_ML_MIN_LANE_CHANGE_ONR_TO_FRWY` Item header constant
    `private static java.lang.String` | `STR_ML_MIN_LANE_CHANGE_ONR_TO_OFR` Item header constant
    `private static java.lang.String` | `STR_ML_NUM_LANES` Item header constant
    `private static java.lang.String` | `STR_ML_NUM_LANES_WEAVING` Item header constant
    `private static java.lang.String` | `STR_ML_NUM_OFF_RAMP_LANES` Item header constant
    `private static java.lang.String` | `STR_ML_NUM_ON_RAMP_LANES` Item header constant
    `private static java.lang.String` | `STR_ML_OCCU` Item header constant
    `private static java.lang.String` | `STR_ML_OFF_RAMP_DEMAND_VEH` Item header constant
    `private static java.lang.String` | `STR_ML_OFF_RAMP_FREE_FLOW_SPEED` Item header constant
    `private static java.lang.String` | `STR_ML_OFF_RAMP_SIDE` Item header constant
    `private static java.lang.String` | `STR_ML_ON_RAMP_DEMAND_VEH` Item header constant
    `private static java.lang.String` | `STR_ML_ON_RAMP_FREE_FLOW_SPEED` Item header constant
    `private static java.lang.String` | `STR_ML_ON_RAMP_SIDE` Item header constant
    `private static java.lang.String` | `STR_ML_RAMP_TO_RAMP_DEMAND_VEH` Item header constant
    `private static java.lang.String` | `STR_ML_SEGMENT_TYPE` Item header constant
    `private static java.lang.String` | `STR_ML_SEPARATION_TYPE` Item header constant
    `private static java.lang.String` | `STR_ML_TRUCK_SINGLE_PERCENTAGE` Item header constant
    `private static java.lang.String` | `STR_ML_TRUCK_TRAILER_PERCENTAGE` Item header constant
    `private static java.lang.String` | `STR_ML_UCAF` Item header constant
    `private static java.lang.String` | `STR_ML_UDAF` Item header constant
    `private static java.lang.String` | `STR_ML_UOAF` Item header constant
    `private static java.lang.String` | `STR_ML_USAF` Item header constant
    `private static java.lang.String` | `STR_ML_USED` Item header constant
    `private static java.lang.String` | `STR_NUM_LANES` Item header constant
    `private static java.lang.String` | `STR_NUM_LANES_WEAVING` Item header constant
    `private static java.lang.String` | `STR_NUM_OFF_RAMP_LANES` Item header constant
    `private static java.lang.String` | `STR_NUM_ON_RAMP_LANES` Item header constant
    `private static java.lang.String` | `STR_NUM_SEGMENTS` Item header constant
    `private static java.lang.String` | `STR_OFF_RAMP_DEMAND_VEH` Item header constant
    `private static java.lang.String` | `STR_OFF_RAMP_FREE_FLOW_SPEED` Item header constant
    `private static java.lang.String` | `STR_OFF_RAMP_SIDE` Item header constant
    `private static java.lang.String` | `STR_ON_RAMP_DEMAND_VEH` Item header constant
    `private static java.lang.String` | `STR_ON_RAMP_FREE_FLOW_SPEED` Item header constant
    `private static java.lang.String` | `STR_ON_RAMP_METERING_RATE` Item header constant
    `private static java.lang.String` | `STR_ON_RAMP_SIDE` Item header constant
    `private static java.lang.String` | `STR_PROJECT_NAME` Item header constant
    `private static java.lang.String` | `STR_RAMP_METERING` Item header constant
    `private static java.lang.String` | `STR_RAMP_TO_RAMP_DEMAND_VEH` Item header constant
    `private static java.lang.String` | `STR_SEED_DEMAND_DATE` Item header constant
    `private static java.lang.String` | `STR_SEGMENT_LENGTH` Item header constant
    `private static java.lang.String` | `STR_SEGMENT_TYPE` Item header constant
    `private static java.lang.String` | `STR_SEGMENT_WIDTH` Item header constant
    `private static java.lang.String` | `STR_START` Item header constant
    `private static java.lang.String` | `STR_TERRAIN` Item header constant
    `private static java.lang.String` | `STR_TRUCK_CAR_EQ` Item header constant
    `private static java.lang.String` | `STR_TRUCK_SINGLE_PERCENTAGE` Item header constant
    `private static java.lang.String` | `STR_TRUCK_TRAILER_PERCENTAGE` Item header constant
    `private static java.lang.String` | `STR_U_CAF` Item header constant
    `private static java.lang.String` | `STR_U_DAF` Item header constant
    `private static java.lang.String` | `STR_U_DPCAF` Item header constant
    `private static java.lang.String` | `STR_U_DPSAF` Item header constant
    `private static java.lang.String` | `STR_U_OAF` Item header constant
    `private static java.lang.String` | `STR_U_SAF` Item header constant
    `private static java.lang.String` | `STR_URBAN_RURAL` Item header constant
    `private static int` | `STRING` Data type marker
    `private static int` | `TIME_DEPENDENT` Data type marker
    `private static int` | `TIME_INDEPENDENT` Data type marker

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ASCIISeedFileAdapter_GPMLFormat()` Constructor

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `private java.lang.String` | `alignString(java.lang.String str)` Align outputs by adding spaces
    `private void` | `buildGPList()` Build GP list
    `private void` | `buildIDMap()` Build ID map
    `private void` | `buildMLList()` Build ML list
    `java.lang.String` | `exportToASCII(Seed seed, javax.swing.JFrame parent)` Export input of seed instance to an ASCII(text) file
    `void` | `exportToASCII(Seed seed, java.lang.String newFileName)` Export input of seed instance to an ASCII(text) file
    `private ASCIISeedFileAdapter_GPMLFormat.Item` | `findItem(java.lang.String headerID)` Find item from list
    `Seed` | `importFromASCII()` Import a Seed instance from an ASCII file (selected by user using file chooser)
    `Seed` | `importFromASCII(java.lang.String fileName)` Import a Seed instance from an ASCII file
    `private void` | `readGeneralInfo(Seed seed, ASCIISeedFileAdapter_GPMLFormat.Item item, java.io.BufferedReader in)` Read general info
    `private void` | `readTimeDependent(Seed seed, ASCIISeedFileAdapter_GPMLFormat.Item item, java.io.BufferedReader in)` Read time dependent data
    `private void` | `readTimeIndependent(Seed seed, ASCIISeedFileAdapter_GPMLFormat.Item item, java.io.BufferedReader in)` Read time independent data
    `private void` | `writeGeneralInfo(Seed seed, ASCIISeedFileAdapter_GPMLFormat.Item item, java.io.BufferedWriter out)` Write general information data
    `private void` | `writeHeader(java.lang.String headerID, java.io.BufferedWriter out)` Write header
    `private void` | `writeItem(Seed seed, ASCIISeedFileAdapter_GPMLFormat.Item item, java.io.BufferedWriter out)` Write data
    `private void` | `writeSegmentIndex(Seed seed, java.io.BufferedWriter out)` Write segment index
    `private void` | `writeTimeDependent(Seed seed, ASCIISeedFileAdapter_GPMLFormat.Item item, java.io.BufferedWriter out)` Write time dependent data
    `private void` | `writeTimeIndependent(Seed seed, ASCIISeedFileAdapter_GPMLFormat.Item item, java.io.BufferedWriter out)` Write time independent data

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### formatter

          private static final java.text.DecimalFormat formatter

      The output formatter

    - #### TIME_DEPENDENT

          private static final int TIME_DEPENDENT

      Data type marker
      See Also:
        Constant Field Values

    - #### TIME_INDEPENDENT

          private static final int TIME_INDEPENDENT

      Data type marker
      See Also:
        Constant Field Values

    - #### GENERAL_INFO

          private static final int GENERAL_INFO

      Data type marker
      See Also:
        Constant Field Values

    - #### INTEGER

          private static final int INTEGER

      Data type marker
      See Also:
        Constant Field Values

    - #### FLOAT

          private static final int FLOAT

      Data type marker
      See Also:
        Constant Field Values

    - #### BOOLEAN

          private static final int BOOLEAN

      Data type marker
      See Also:
        Constant Field Values

    - #### STRING

          private static final int STRING

      Data type marker
      See Also:
        Constant Field Values

    - #### OTHER

          private static final int OTHER

      Data type marker
      See Also:
        Constant Field Values

    - #### ITEM_WIDTH

          private static final int ITEM_WIDTH

      Format marker
      See Also:
        Constant Field Values

    - #### idToHeaderMap

          private final java.util.HashMap<java.lang.String,java.lang.String> idToHeaderMap

      Map to convert id to header

    - #### ID_PROJECT_NAME

          private static final java.lang.String ID_PROJECT_NAME

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_START

          private static final java.lang.String ID_START

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_END

          private static final java.lang.String ID_END

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_NUM_SEGMENTS

          private static final java.lang.String ID_NUM_SEGMENTS

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_FFS_KNOWN

          private static final java.lang.String ID_FFS_KNOWN

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_USED

          private static final java.lang.String ID_ML_USED

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ALPHA

          private static final java.lang.String ID_ALPHA

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_JAM_DENSITY

          private static final java.lang.String ID_JAM_DENSITY

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_SEED_DEMAND_DATE

          private static final java.lang.String ID_SEED_DEMAND_DATE

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_GP_OCCU

          private static final java.lang.String ID_GP_OCCU

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_OCCU

          private static final java.lang.String ID_ML_OCCU

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_URBAN_RURAL

          private static final java.lang.String ID_URBAN_RURAL

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_SEGMENT_TYPE

          private static final java.lang.String ID_SEGMENT_TYPE

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_SEGMENT_LENGTH

          private static final java.lang.String ID_SEGMENT_LENGTH

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_SEGMENT_WIDTH

          private static final java.lang.String ID_SEGMENT_WIDTH

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_LATERAL_CLEARANCE

          private static final java.lang.String ID_LATERAL_CLEARANCE

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_TERRAIN

          private static final java.lang.String ID_TERRAIN

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_TRUCK_CAR_EQ

          private static final java.lang.String ID_TRUCK_CAR_EQ

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_NUM_LANES

          private static final java.lang.String ID_NUM_LANES

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_FREE_FLOW_SPEED

          private static final java.lang.String ID_FREE_FLOW_SPEED

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_DEMAND_VEH

          private static final java.lang.String ID_DEMAND_VEH

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_TRUCK_SINGLE_PERCENTAGE

          private static final java.lang.String ID_TRUCK_SINGLE_PERCENTAGE

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_TRUCK_TRAILER_PERCENTAGE

          private static final java.lang.String ID_TRUCK_TRAILER_PERCENTAGE

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_U_CAF

          private static final java.lang.String ID_U_CAF

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_U_OAF

          private static final java.lang.String ID_U_OAF

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_U_DAF

          private static final java.lang.String ID_U_DAF

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_U_SAF

          private static final java.lang.String ID_U_SAF

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ON_RAMP_SIDE

          private static final java.lang.String ID_ON_RAMP_SIDE

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ACC_DEC_LANE_LENGTH

          private static final java.lang.String ID_ACC_DEC_LANE_LENGTH

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_NUM_ON_RAMP_LANES

          private static final java.lang.String ID_NUM_ON_RAMP_LANES

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ON_RAMP_DEMAND_VEH

          private static final java.lang.String ID_ON_RAMP_DEMAND_VEH

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ON_RAMP_FREE_FLOW_SPEED

          private static final java.lang.String ID_ON_RAMP_FREE_FLOW_SPEED

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ON_RAMP_METERING_RATE

          private static final java.lang.String ID_ON_RAMP_METERING_RATE

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_OFF_RAMP_SIDE

          private static final java.lang.String ID_OFF_RAMP_SIDE

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_NUM_OFF_RAMP_LANES

          private static final java.lang.String ID_NUM_OFF_RAMP_LANES

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_OFF_RAMP_DEMAND_VEH

          private static final java.lang.String ID_OFF_RAMP_DEMAND_VEH

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_OFF_RAMP_FREE_FLOW_SPEED

          private static final java.lang.String ID_OFF_RAMP_FREE_FLOW_SPEED

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_LENGTH_OF_WEAVING

          private static final java.lang.String ID_LENGTH_OF_WEAVING

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_MIN_LANE_CHANGE_ONR_TO_FRWY

          private static final java.lang.String ID_MIN_LANE_CHANGE_ONR_TO_FRWY

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_MIN_LANE_CHANGE_FRWY_TO_OFR

          private static final java.lang.String ID_MIN_LANE_CHANGE_FRWY_TO_OFR

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_MIN_LANE_CHANGE_ONR_TO_OFR

          private static final java.lang.String ID_MIN_LANE_CHANGE_ONR_TO_OFR

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_NUM_LANES_WEAVING

          private static final java.lang.String ID_NUM_LANES_WEAVING

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_RAMP_TO_RAMP_DEMAND_VEH

          private static final java.lang.String ID_RAMP_TO_RAMP_DEMAND_VEH

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_RAMP_METERING

          private static final java.lang.String ID_RAMP_METERING

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_U_DPCAF

          private static final java.lang.String ID_U_DPCAF

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_U_DPSAF

          private static final java.lang.String ID_U_DPSAF

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_SEGMENT_TYPE

          private static final java.lang.String ID_ML_SEGMENT_TYPE

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_SEPARATION_TYPE

          private static final java.lang.String ID_ML_SEPARATION_TYPE

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_NUM_LANES

          private static final java.lang.String ID_ML_NUM_LANES

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_FREE_FLOW_SPEED

          private static final java.lang.String ID_ML_FREE_FLOW_SPEED

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_DEMAND_VEH

          private static final java.lang.String ID_ML_DEMAND_VEH

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_TRUCK_SINGLE_PERCENTAGE

          private static final java.lang.String ID_ML_TRUCK_SINGLE_PERCENTAGE

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_TRUCK_TRAILER_PERCENTAGE

          private static final java.lang.String ID_ML_TRUCK_TRAILER_PERCENTAGE

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_UCAF

          private static final java.lang.String ID_ML_UCAF

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_UOAF

          private static final java.lang.String ID_ML_UOAF

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_UDAF

          private static final java.lang.String ID_ML_UDAF

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_USAF

          private static final java.lang.String ID_ML_USAF

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_ACC_DEC_LANE_LENGTH

          private static final java.lang.String ID_ML_ACC_DEC_LANE_LENGTH

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_ON_RAMP_SIDE

          private static final java.lang.String ID_ML_ON_RAMP_SIDE

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_NUM_ON_RAMP_LANES

          private static final java.lang.String ID_ML_NUM_ON_RAMP_LANES

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_ON_RAMP_DEMAND_VEH

          private static final java.lang.String ID_ML_ON_RAMP_DEMAND_VEH

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_ON_RAMP_FREE_FLOW_SPEED

          private static final java.lang.String ID_ML_ON_RAMP_FREE_FLOW_SPEED

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_OFF_RAMP_SIDE

          private static final java.lang.String ID_ML_OFF_RAMP_SIDE

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_NUM_OFF_RAMP_LANES

          private static final java.lang.String ID_ML_NUM_OFF_RAMP_LANES

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_OFF_RAMP_DEMAND_VEH

          private static final java.lang.String ID_ML_OFF_RAMP_DEMAND_VEH

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_OFF_RAMP_FREE_FLOW_SPEED

          private static final java.lang.String ID_ML_OFF_RAMP_FREE_FLOW_SPEED

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_LENGTH_SHORT

          private static final java.lang.String ID_ML_LENGTH_SHORT

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_MIN_LANE_CHANGE_ONR_TO_FRWY

          private static final java.lang.String ID_ML_MIN_LANE_CHANGE_ONR_TO_FRWY

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_MIN_LANE_CHANGE_FRWY_TO_OFR

          private static final java.lang.String ID_ML_MIN_LANE_CHANGE_FRWY_TO_OFR

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_MIN_LANE_CHANGE_ONR_TO_OFR

          private static final java.lang.String ID_ML_MIN_LANE_CHANGE_ONR_TO_OFR

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_NUM_LANES_WEAVING

          private static final java.lang.String ID_ML_NUM_LANES_WEAVING

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_LC_MIN

          private static final java.lang.String ID_ML_LC_MIN

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_LC_MAX

          private static final java.lang.String ID_ML_LC_MAX

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_RAMP_TO_RAMP_DEMAND_VEH

          private static final java.lang.String ID_ML_RAMP_TO_RAMP_DEMAND_VEH

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_HAS_CROSS_WEAVE

          private static final java.lang.String ID_ML_HAS_CROSS_WEAVE

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_CROSS_WEAVE_LC_MIN

          private static final java.lang.String ID_ML_CROSS_WEAVE_LC_MIN

      Item ID constant
      See Also:
        Constant Field Values

    - #### ID_ML_CROSS_WEAVE_VOLUME

          private static final java.lang.String ID_ML_CROSS_WEAVE_VOLUME

      Item ID constant
      See Also:
        Constant Field Values

    - #### STR_PROJECT_NAME

          private static final java.lang.String STR_PROJECT_NAME

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_START

          private static final java.lang.String STR_START

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_END

          private static final java.lang.String STR_END

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_NUM_SEGMENTS

          private static final java.lang.String STR_NUM_SEGMENTS

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_FFS_KNOWN

          private static final java.lang.String STR_FFS_KNOWN

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_RAMP_METERING

          private static final java.lang.String STR_RAMP_METERING

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_USED

          private static final java.lang.String STR_ML_USED

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ALPHA

          private static final java.lang.String STR_ALPHA

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_JAM_DENSITY

          private static final java.lang.String STR_JAM_DENSITY

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_SEED_DEMAND_DATE

          private static final java.lang.String STR_SEED_DEMAND_DATE

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_GP_OCCU

          private static final java.lang.String STR_GP_OCCU

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_OCCU

          private static final java.lang.String STR_ML_OCCU

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_URBAN_RURAL

          private static final java.lang.String STR_URBAN_RURAL

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_SEGMENT_TYPE

          private static final java.lang.String STR_SEGMENT_TYPE

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_SEGMENT_LENGTH

          private static final java.lang.String STR_SEGMENT_LENGTH

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_SEGMENT_WIDTH

          private static final java.lang.String STR_SEGMENT_WIDTH

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_LATERAL_CLEARANCE

          private static final java.lang.String STR_LATERAL_CLEARANCE

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_TERRAIN

          private static final java.lang.String STR_TERRAIN

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_TRUCK_CAR_EQ

          private static final java.lang.String STR_TRUCK_CAR_EQ

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_NUM_LANES

          private static final java.lang.String STR_NUM_LANES

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_FREE_FLOW_SPEED

          private static final java.lang.String STR_FREE_FLOW_SPEED

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_DEMAND_VEH

          private static final java.lang.String STR_DEMAND_VEH

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_TRUCK_SINGLE_PERCENTAGE

          private static final java.lang.String STR_TRUCK_SINGLE_PERCENTAGE

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_TRUCK_TRAILER_PERCENTAGE

          private static final java.lang.String STR_TRUCK_TRAILER_PERCENTAGE

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_U_CAF

          private static final java.lang.String STR_U_CAF

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_U_OAF

          private static final java.lang.String STR_U_OAF

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_U_DAF

          private static final java.lang.String STR_U_DAF

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_U_SAF

          private static final java.lang.String STR_U_SAF

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_U_DPCAF

          private static final java.lang.String STR_U_DPCAF

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_U_DPSAF

          private static final java.lang.String STR_U_DPSAF

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ON_RAMP_SIDE

          private static final java.lang.String STR_ON_RAMP_SIDE

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ACC_DEC_LANE_LENGTH

          private static final java.lang.String STR_ACC_DEC_LANE_LENGTH

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_NUM_ON_RAMP_LANES

          private static final java.lang.String STR_NUM_ON_RAMP_LANES

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ON_RAMP_DEMAND_VEH

          private static final java.lang.String STR_ON_RAMP_DEMAND_VEH

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ON_RAMP_FREE_FLOW_SPEED

          private static final java.lang.String STR_ON_RAMP_FREE_FLOW_SPEED

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ON_RAMP_METERING_RATE

          private static final java.lang.String STR_ON_RAMP_METERING_RATE

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_OFF_RAMP_SIDE

          private static final java.lang.String STR_OFF_RAMP_SIDE

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_NUM_OFF_RAMP_LANES

          private static final java.lang.String STR_NUM_OFF_RAMP_LANES

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_OFF_RAMP_DEMAND_VEH

          private static final java.lang.String STR_OFF_RAMP_DEMAND_VEH

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_OFF_RAMP_FREE_FLOW_SPEED

          private static final java.lang.String STR_OFF_RAMP_FREE_FLOW_SPEED

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_LENGTH_OF_WEAVING

          private static final java.lang.String STR_LENGTH_OF_WEAVING

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_MIN_LANE_CHANGE_ONR_TO_FRWY

          private static final java.lang.String STR_MIN_LANE_CHANGE_ONR_TO_FRWY

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_MIN_LANE_CHANGE_FRWY_TO_OFR

          private static final java.lang.String STR_MIN_LANE_CHANGE_FRWY_TO_OFR

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_MIN_LANE_CHANGE_ONR_TO_OFR

          private static final java.lang.String STR_MIN_LANE_CHANGE_ONR_TO_OFR

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_NUM_LANES_WEAVING

          private static final java.lang.String STR_NUM_LANES_WEAVING

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_RAMP_TO_RAMP_DEMAND_VEH

          private static final java.lang.String STR_RAMP_TO_RAMP_DEMAND_VEH

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_SEGMENT_TYPE

          private static final java.lang.String STR_ML_SEGMENT_TYPE

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_METHOD_TYPE

          private static final java.lang.String STR_ML_METHOD_TYPE

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_SEPARATION_TYPE

          private static final java.lang.String STR_ML_SEPARATION_TYPE

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_NUM_LANES

          private static final java.lang.String STR_ML_NUM_LANES

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_FREE_FLOW_SPEED

          private static final java.lang.String STR_ML_FREE_FLOW_SPEED

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_DEMAND_VEH

          private static final java.lang.String STR_ML_DEMAND_VEH

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_TRUCK_SINGLE_PERCENTAGE

          private static final java.lang.String STR_ML_TRUCK_SINGLE_PERCENTAGE

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_TRUCK_TRAILER_PERCENTAGE

          private static final java.lang.String STR_ML_TRUCK_TRAILER_PERCENTAGE

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_UCAF

          private static final java.lang.String STR_ML_UCAF

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_UOAF

          private static final java.lang.String STR_ML_UOAF

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_UDAF

          private static final java.lang.String STR_ML_UDAF

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_USAF

          private static final java.lang.String STR_ML_USAF

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_ACC_DEC_LANE_LENGTH

          private static final java.lang.String STR_ML_ACC_DEC_LANE_LENGTH

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_ON_RAMP_SIDE

          private static final java.lang.String STR_ML_ON_RAMP_SIDE

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_NUM_ON_RAMP_LANES

          private static final java.lang.String STR_ML_NUM_ON_RAMP_LANES

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_ON_RAMP_DEMAND_VEH

          private static final java.lang.String STR_ML_ON_RAMP_DEMAND_VEH

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_ON_RAMP_FREE_FLOW_SPEED

          private static final java.lang.String STR_ML_ON_RAMP_FREE_FLOW_SPEED

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_OFF_RAMP_SIDE

          private static final java.lang.String STR_ML_OFF_RAMP_SIDE

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_NUM_OFF_RAMP_LANES

          private static final java.lang.String STR_ML_NUM_OFF_RAMP_LANES

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_OFF_RAMP_DEMAND_VEH

          private static final java.lang.String STR_ML_OFF_RAMP_DEMAND_VEH

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_OFF_RAMP_FREE_FLOW_SPEED

          private static final java.lang.String STR_ML_OFF_RAMP_FREE_FLOW_SPEED

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_LENGTH_SHORT

          private static final java.lang.String STR_ML_LENGTH_SHORT

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_MIN_LANE_CHANGE_ONR_TO_FRWY

          private static final java.lang.String STR_ML_MIN_LANE_CHANGE_ONR_TO_FRWY

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_MIN_LANE_CHANGE_FRWY_TO_OFR

          private static final java.lang.String STR_ML_MIN_LANE_CHANGE_FRWY_TO_OFR

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_MIN_LANE_CHANGE_ONR_TO_OFR

          private static final java.lang.String STR_ML_MIN_LANE_CHANGE_ONR_TO_OFR

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_NUM_LANES_WEAVING

          private static final java.lang.String STR_ML_NUM_LANES_WEAVING

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_LC_MIN

          private static final java.lang.String STR_ML_LC_MIN

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_LC_MAX

          private static final java.lang.String STR_ML_LC_MAX

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_RAMP_TO_RAMP_DEMAND_VEH

          private static final java.lang.String STR_ML_RAMP_TO_RAMP_DEMAND_VEH

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_HAS_CROSS_WEAVE

          private static final java.lang.String STR_ML_HAS_CROSS_WEAVE

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_CROSS_WEAVE_LC_MIN

          private static final java.lang.String STR_ML_CROSS_WEAVE_LC_MIN

      Item header constant
      See Also:
        Constant Field Values

    - #### STR_ML_CROSS_WEAVE_VOLUME

          private static final java.lang.String STR_ML_CROSS_WEAVE_VOLUME

      Item header constant
      See Also:
        Constant Field Values

    - #### itemListGP

          private final java.util.ArrayList<ASCIISeedFileAdapter_GPMLFormat.Item> itemListGP

      Item list for general purpose segments

    - #### itemListML

          private final java.util.ArrayList<ASCIISeedFileAdapter_GPMLFormat.Item> itemListML

      Item list for managed lanes segments

  - ### Constructor Detail

    - #### ASCIISeedFileAdapter_GPMLFormat

          public ASCIISeedFileAdapter_GPMLFormat()

      Constructor

  - ### Method Detail

    - #### buildIDMap

          private void buildIDMap()

      Build ID map

    - #### buildGPList

          private void buildGPList()

      Build GP list

    - #### buildMLList

          private void buildMLList()

      Build ML list

    - #### importFromASCII

          public Seed importFromASCII()

      Import a Seed instance from an ASCII file (selected by user using file chooser)
      Returns:
        a Seed instance

    - #### importFromASCII

          public Seed importFromASCII(java.lang.String fileName)

      Import a Seed instance from an ASCII file
      Parameters:
        `fileName` - path of the ASCII file
      Returns:
        a Seed instance

    - #### findItem

          private ASCIISeedFileAdapter_GPMLFormat.Item findItem(java.lang.String headerID)

      Find item from list
      Parameters:
        `headerID` - header ID
      Returns:
        item from list

    - #### readGeneralInfo

          private void readGeneralInfo(Seed seed,
                                       ASCIISeedFileAdapter_GPMLFormat.Item item,
                                       java.io.BufferedReader in)
                                throws java.io.IOException

      Read general info
      Parameters:
        `seed` - seed instance
        `item` - item to be read
        `in` - input reader
      Throws:
        `java.io.IOException`

    - #### readTimeIndependent

          private void readTimeIndependent(Seed seed,
                                           ASCIISeedFileAdapter_GPMLFormat.Item item,
                                           java.io.BufferedReader in)
                                    throws java.io.IOException

      Read time independent data
      Parameters:
        `seed` - seed instance
        `item` - item to be read
        `in` - input reader
      Throws:
        `java.io.IOException`

    - #### readTimeDependent

          private void readTimeDependent(Seed seed,
                                         ASCIISeedFileAdapter_GPMLFormat.Item item,
                                         java.io.BufferedReader in)
                                  throws java.io.IOException

      Read time dependent data
      Parameters:
        `seed` - seed instance
        `item` - item to be read
        `in` - input reader
      Throws:
        `java.io.IOException`

    - #### exportToASCII

          public java.lang.String exportToASCII(Seed seed,
                                                javax.swing.JFrame parent)

      Export input of seed instance to an ASCII(text) file
      Parameters:
        `seed` - seed instance
        `parent` - For location of fileChooser. Can be null.
      Returns:
        file path and name

    - #### exportToASCII

          public void exportToASCII(Seed seed,
                                    java.lang.String newFileName)

      Export input of seed instance to an ASCII(text) file
      Parameters:
        `seed` - seed instance
        `newFileName` - file path and name

    - #### writeItem

          private void writeItem(Seed seed,
                                 ASCIISeedFileAdapter_GPMLFormat.Item item,
                                 java.io.BufferedWriter out)
                          throws java.io.IOException

      Write data
      Parameters:
        `seed` - seed instance
        `item` - item to be written
        `out` - output writer
      Throws:
        `java.io.IOException`

    - #### writeGeneralInfo

          private void writeGeneralInfo(Seed seed,
                                        ASCIISeedFileAdapter_GPMLFormat.Item item,
                                        java.io.BufferedWriter out)
                                 throws java.io.IOException

      Write general information data
      Parameters:
        `seed` - seed instance
        `item` - item to be written
        `out` - output writer
      Throws:
        `java.io.IOException`

    - #### writeTimeDependent

          private void writeTimeDependent(Seed seed,
                                          ASCIISeedFileAdapter_GPMLFormat.Item item,
                                          java.io.BufferedWriter out)
                                   throws java.io.IOException

      Write time dependent data
      Parameters:
        `seed` - seed instance
        `item` - item to be written
        `out` - output writer
      Throws:
        `java.io.IOException`

    - #### writeTimeIndependent

          private void writeTimeIndependent(Seed seed,
                                            ASCIISeedFileAdapter_GPMLFormat.Item item,
                                            java.io.BufferedWriter out)
                                     throws java.io.IOException

      Write time independent data
      Parameters:
        `seed` - seed instance
        `item` - item to be written
        `out` - output writer
      Throws:
        `java.io.IOException`

    - #### writeHeader

          private void writeHeader(java.lang.String headerID,
                                   java.io.BufferedWriter out)
                            throws java.io.IOException

      Write header
      Parameters:
        `headerID` - header ID
        `out` - output writer
      Throws:
        `java.io.IOException`

    - #### writeSegmentIndex

          private void writeSegmentIndex(Seed seed,
                                         java.io.BufferedWriter out)
                                  throws java.io.IOException

      Write segment index
      Parameters:
        `seed` - seed instance
        `out` - output writer
      Throws:
        `java.io.IOException`

    - #### alignString

          private java.lang.String alignString(java.lang.String str)

      Align outputs by adding spaces
      Parameters:
        `str` - output string
      Returns:
        formatted string